/* SCHEDULER SCAN */
#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <unistd.h>

#define TRUE 1
#define FALSE 0
#define NPROC 1
int num_proc;

void
padre_alarm ()
{
  printf(" Arrivato SIGALRM\n");
  signal (SIGALRM, padre_alarm);
}

void
catcher_user_alarm ()
{
  signal (SIGALRM, catcher_user_alarm);
}

void
processo_utente ()
{
  int  pid, attesa;

  setbuf(stdout,0);
  signal (SIGALRM, catcher_user_alarm);
  pid = getpid ();
  fprintf (stderr, "Nasce il processo %d num_proc: %d\n", pid, num_proc);
  srand (pid);

  for(;;)
  {
    attesa = 1 + (int) (10.0 * rand () / (RAND_MAX + 1.0));
    alarm (10);
    pause ();			/* attesa 1-10 sec */
  }
}
int
main ()
{

  int childpid, attesa;
  char s[132];

  signal (SIGALRM, padre_alarm);
  for (num_proc = 0; num_proc < NPROC; num_proc++)
    if ((childpid = fork ()) == 0)
      processo_utente ();

  /*      padre  */

  srand (getpid());
  while (1) {
    attesa = 1 + (int) (10.0 * rand () / (RAND_MAX + 1.0));
    alarm(attesa);
    printf("Aspetto il clock :\n");
    gets(s);
  }
}

