#include <stdio.h>
#include <stdlib.h>

typedef int * semaforo;
semaforo s1,s2;

semaforo
make_sem()
{
int *sem;

sem = calloc(2,sizeof(int));
pipe(sem);
return sem;
}

void
wait(semaforo s)
{
int junk;

if (read(s[0], &junk, 1) <=0) {
  fprintf(stderr, "ERRORE : wait\n");
   exit(1);
   }
}

void
signal(semaforo s)
{

if (write(s[1], "s", 1) <=0) {
  fprintf(stderr, "ERRORE : signal\n");
   exit(1);
   }
}


int
main()
{
  int i=0;

  s1 = make_sem();
  s2 = make_sem();

  setbuf(stdout, 0);

  if(fork() == 0){
    // figlio
    for(;;) {
      printf("sono il figlio\n");
      wait(s1);
      printf("ricevuto da padre %d\n", i++);
      signal(s2);
    }
  }
  else {
    // padre
    for(;;) {
      sleep(10);
      printf("sono il padre\n");
      signal(s1);
      wait(s2);
      printf("ricevuto risposta %d\n",i++);
    }
  }
  
;
exit(0);
}
