#include <stdio.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <sys/types.h>
#define MAXBUFF 512

char            buffer[512];


void
copy(old, new)
  int             old, new;
{
  int             count;

  while ((count = read(old, buffer, MAXBUFF)) > 0)
    write(new, buffer, count);
}

int
main(argc, argv)
  int             argc;
  char           *argv[];
{
  int             fold, fnew;

  if (argc != 3) {
    fprintf(stderr,
	    "%s file1 file2\n", argv[0]);
    exit(-1);
  }
  if ((fold = open(argv[1], O_RDONLY)) < 0) {
    fprintf(stderr, "errore file %s\n", argv[1]);
    exit(-1);
  }
  if ((fnew = creat(argv[2], 0600)) < 0) {
    fprintf(stderr, "errore file %s\n", argv[2]);
    exit(-1);
  }
  copy(fold, fnew);
}
