/*		ESEMPIO spazio degli indirizzi dopo fork */

#include <sys/types.h>
#include <sys/wait.h>

int debug = 1;
char *progname;

main(argc, argv)
int argc;
char *argv[];

{
  int i;
  char *ptr, *malloc();
  pid_t           childpid;

  progname = argv[0];
  printf("argc = %d\n", argc);
  for (i = 1; i < argc; i++){
    ptr = malloc(strlen(argv[i]) + 1);
    strcpy(ptr, argv[i]);
    if (debug)
      printf("debug %d %x -> %s\n", debug, ptr, ptr);
  }
  if ((childpid = fork()) == -1)
    err_sys("can't fork");
  if (childpid == 0) {
    printf("child: child pid = %d, parent pid = %d, debug %d %x \n",
	   getpid(), getppid(), debug, ptr);
      printf("%s\n", ptr);
    exit(0);
  } 
}
