/*
 *  prova_exit.c
 *
 * prova_exit e pthread_exit
 */
#include <pthread.h>
#include "errors.h"

int k, m;

void *print_thread (void *arg)
{
    int * k = (int *)arg;

    int status, i;


    status = pthread_detach (pthread_self ());
    if (status != 0)
        err_abort (status, "Detach thread");
    for (i = *k; i < *k+10; i++) {
      sleep (1);
      printf ("Thread attivo %d\n", i);
    }
    return NULL;
}

int main (int argc, char *argv[])
{
    int status;
 
    pthread_t thread;

    printf ("Dammi un intero >  ");
    scanf("%d", &k);
 
    status = pthread_create (&thread, NULL, print_thread, &k);
    if (status != 0)
      err_abort (status, "Create print thread");
    m = k+100;
    status = pthread_create (&thread, NULL, print_thread, &m);
    if (status != 0)
      err_abort (status, "Create print thread");

//    pthread_exit(NULL); // finisce solo questo thread

    sleep(6);
    exit(0); 		// termina il processo (tutti i threads)
    

}
