#include <stdio.h>

main(argc, argv)
  int             argc;
  char           *argv[];
{

  int             i, j, n, readerpid, squashpid;
  int             pipers[2], pipesp[2];
  char            outbuf[125], rs, sp;
  FILE           *fpc;

  char            stringa[132], *s;

  if (argc != 2) {
    fprintf(stderr,
	    "comando : %s file input\n", argv[0]);
    exit(-1);
  }
  if ((fpc = (fopen(argv[1], "r"))) == NULL) {
    fprintf(stderr, "errore file %s\n", argv[1]);
    exit(-1);
  }
  if (pipe(pipers) < 0 || pipe(pipesp) < 0)
    err_sys("can't create pipes");

  s = stringa;

  if ((squashpid = fork()) < 0)	/* printer - e' il padre di tutti */
    err_sys("can't fork squash");

  if (squashpid > 0) {		/* printer */
    if ((readerpid = fork()) < 0)
      err_sys("can't fork reader");

    if (readerpid == 0) {	/* reader - e' figlio di printer */
      close(pipers[0]);		/* non deve leggere da pipers */
      close(pipesp[0]);		/* non deve conoscere pipesp */
      close(pipesp[1]);		/* non deve conoscere pipesp */

      for (;;) {
	fgets(s, 80, fpc);
	if (stringa[0] == '?') {
	  close(pipers[1]);
	  exit(0);
	}
	for (i = 0; stringa[i] != '\n'; i++)
	  write(pipers[1], &stringa[i], 1);
	rs = ' ';
	write(pipers[1], &rs, 1);
      }
    } else {			/* readerpid > 0 - continua printer */
      close(pipesp[1]);		/* non deve scrivere su pipesp */
      close(pipers[0]);		/* non deve conoscere pipers */
      close(pipers[1]);

      for (;;) {
	for (j = 0; j < 125; j++)
	  if ((n = read(pipesp[0], &outbuf[j], 1)) != 1)
	    exit(0);
	for (j = 0; j < 125; j++)
	  printf("%c", outbuf[j]);
	printf("\n");
      }
    }
  } else {			/* squashpid = 0 */
				/* squash - e' figlio di printer */
    close(pipers[1]);		/* non deve scrivere su pipers */
    close(pipesp[0]);		/* non deve leggere da pipesp */

    for (;;) {
      if ((n = read(pipers[0], &rs, 1)) != 1)
	exit(0);
      if (rs != '*')
	write(pipesp[1], &rs, 1);
      else {
	if ((n = read(pipers[0], &rs, 1)) != 1)
	  exit(0);
	if (rs == '*') {
	  sp = '|';
	  write(pipesp[1], &sp, 1);
	} else {
	  sp = '*';
	  write(pipesp[1], &sp, 1);
	  sp = rs;
	  write(pipesp[1], &sp, 1);
	}
      }
    }
  }
}
