#include <stdio.h>
#include <sys/file.h>
#define SEQFILE "seqno"
#define MAXBUFF 100

main()
{
  int fd, i, n, pid, seqno;
  char buff[MAXBUFF + 1];

  setbuf(stdout,0);
  pid = getpid();
  if ((fd = open(SEQFILE, O_RDWR)) < 0)
    err_sys("can't open %", SEQFILE);

  for (i = 0; i < 100; i++) {
    my_lock(fd);
    lseek(fd, 0L,0);
    if ((n = read(fd, buff, MAXBUFF)) <= 0)
      err_sys("read error");
    buff[n] = '\0';
    if ( (n = sscanf(buff, "%d\n", &seqno)) !=1)
      err_sys("sscanf error");
    printf("pid = %d, seq# = %d\n", pid, seqno);

    seqno++;

    sprintf(buff, "%03d\n", seqno);
    n = strlen(buff);
    lseek(fd, 0L, 0);
    if (write(fd, buff, n) != n)
      err_sys("write error");
    my_unlock(fd);
  }
}
