/* uso di signal, kill e popen*/

#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <unistd.h>

#define MAXLINE 1024

  FILE *fp, *f12, *f21;
  char stringa[80];
  char fname12[]="mem12.txt";
  char fname21[]="mem21.txt";

char command[MAXLINE];
int pid, childpid; 

void 
catcher_alarm ()
{
  signal (SIGALRM, catcher_alarm);
}

void 
catcher_figlio ()
{
  signal (SIGUSR1, catcher_figlio);
}
void 
catcher_padre ()
{
  signal (SIGUSR1, catcher_padre);
}


void
figlio ()
{
char dummy[80], data[20];

  signal (SIGUSR1, catcher_figlio);

  while (1)
    {
    pause();
    printf ("Sono il processo %d figlio di %d\n", getpid(), getppid());
    fflush(stdout);
    fseek(f12, 0, SEEK_SET);
    fgets(stringa, 80, f12);
    printf("ho letto %s\n", stringa);
    fflush(stdout);
    fputs(stringa, stdout);
    sscanf(stringa, "%s%s%s%s", dummy, dummy, dummy, data);
    printf("ho isolato %s\n", data);
    data[strlen(data)] = 0;
    fseek(f21, 0, SEEK_SET);
    fputs(data,f21);
    kill(getppid(),SIGUSR1);
    }
}


int
main ()
{
  f12 = fopen("mem12.txt", "w+");
  f21 = fopen("mem21.txt", "w+");
  signal (SIGALRM, catcher_alarm);
  signal (SIGUSR1, catcher_padre);

  if ((childpid = fork ()) == 0)
    figlio ();

  while (1)
    {
      alarm(5);
      pause();
      printf ("Sono il processo %d\n", getpid());
      fflush(stdout);
      sprintf(command, "date");
      if ((fp = popen(command, "r")) == NULL)
        perror("popen");
      fgets(stringa, 80, fp);
      pclose(fp);
      fseek(f12, 0, SEEK_SET);
      fputs(stringa, f12);
      kill(childpid, SIGUSR1);
      pause(); 
      fseek(f21, 0, SEEK_SET);
      fgets(stringa, 80, f21);
      printf("Ottenuto: %s\n", stringa);
    }
}
