#include <fcntl.h>
#include <stdio.h>
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>

int
main (void)
{
  fd_set rfds;
  struct timeval tv;
  int retval, n;
  int fd1, fd2, te;
  char c;

  mknod ("npipe1", 0010777, 0);
  mknod ("npipe2", 0010777, 0);
  fd1 = open ("npipe1", O_RDONLY);
  mknod ("npipe2", 0010777, 0);
  fd2 = open ("npipe2", O_RDONLY);


  FD_ZERO (&rfds);

  while (1)
    {
      FD_SET (fd1, &rfds);
      FD_SET (fd2, &rfds);
      tv.tv_sec = 15;
      tv.tv_usec = 0;
      te = tv.tv_sec;

      retval = select (8, &rfds, NULL, NULL, &tv);
      if (retval == -1) 
        exit(0);
      if (retval)
	{
	  if (FD_ISSET (fd1, &rfds))
	    {
	      if ((n=read (fd1, &c, 1)) != 1)
                exit(1);
  	        printf ("%c letto da fd1 fd = %d\n", c, fd1);
	    }
	  else
	    {
	      if ((n=read (fd2, &c, 1)) != 1)
                exit(1);
	      printf ("%c letto da fd2 fd = %d\n", c, fd2);
	    }
	}
      else
	{
	  printf ("Dati non ricevuti entro  %d secondi.\n", te);
	  exit (0);
	}
    }
}
