#include <stdio.h>
#include <sys/file.h>
#define SEQFILE "seqno"
#define MAXBUFF 100


typedef int * semaforo;
semaforo me;

semaforo
make_sem()
{
int *sem;

sem = calloc(2,sizeof(int));
pipe(sem);
return sem;
}

void
wait(semaforo s)
{
int junk;

if (read(s[0], &junk, 1) <=0) {
  fprintf(stderr, "ERRORE : wait\n");
   exit(1);
   }
}

void
signal(semaforo s)
{

if (write(s[1], "s", 1) <=0) {
  fprintf(stderr, "ERRORE : signal\n");
   exit(1);
   }
}

main()
{
  int fd, i, n, pid, seqno;
  char buff[MAXBUFF + 1];

  me = make_sem();
  signal(me);

  setbuf(stdout,0);

  fork();

  pid = getpid();
  if ((fd = open(SEQFILE, O_RDWR)) < 0)
    fprintf(stderr, "errore apertura file\n");

  for (i = 0; i < 100; i++) {
    // wait(me);
    lseek(fd, 0L,0);
    n = read(fd, buff, MAXBUFF);
    buff[n] = '\0';
    sscanf(buff, "%d\n", &seqno);  
    printf("pid = %d, seq# = %d\n", pid, seqno);

    seqno++;

    sprintf(buff, "%03d\n", seqno);
    n = strlen(buff);
    lseek(fd, 0L, 0);
    write(fd, buff, n);
    // signal(me);
  }
}

