/* Esempio system call fork - wait  */

#include <sys/types.h>
#include <sys/wait.h>

main()
{
  pid_t           childpid;

  printf("parent - S1 - pid = %d\n", getpid());
  if ((childpid = fork()) == -1)
    err_sys("can't fork");
  if (childpid == 0) {
    printf("child: child pid = %d, parent pid = %d\n",
	   getpid(), getppid());
    P34();
    exit(0);
  } else {
    sleep(15);
    printf("parent - S2 - pid = %d\n", getpid());
    printf("parent: child pid= %d, parent pid = %d\n",
	   childpid, getpid());
    printf("wait - P34 - \n");
    while (wait((int *) 0) != childpid)	/* wait for child */
      ;

    printf("parent - S5 - pid = %d\n", getpid());
    exit(0);
  }

}

P34()
{
  pid_t           pid4;

  printf("fork - P34 - \n");
  if ((pid4 = fork()) == -1)
    err_sys("can't fork");
  if (pid4 == 0) {
    printf("- S4 - pid = %d, parent pid = %d\n",
	   getpid(), getppid());
    exit(0);
  } else {
    printf("- S3 - pid = %d, parent pid = %d\n",
	   getpid(), getppid());
    while (wait((int *) 0) != pid4)	/* wait for child */
      ;
    printf("end of - P34 - \n");
    exit(0);
  }
}
