/*
Usando link FORTRAN
*/

#define LOCKFILE "seqno.lock"
#include <sys/errno.h>
extern int errno;

my_lock_(fd)
int *fd;
{
  int tempfd;
  char tempfile[30];

  sprintf(tempfile, "LCK%d", getpid());
  if ( (tempfd = creat(tempfile, 0444)) < 0)
    err_sys("can't creat temp file");
  close(tempfd);

  while ( link(tempfile, LOCKFILE) < 0) {
    if (errno != EEXIST)
      err_sys("link error");
    sleep(1);
  }
  if (unlink(tempfile) <0)
    err_sys("unlink error for tempfile");
} 

my_unlock_(fd)
int *fd;
{
  if (unlink(LOCKFILE) <0)
    err_sys("unlink error for LOCKFILE");
}
